<?php

namespace App\Http\Controllers;

use GuzzleHttp\Client;
use Closure;

Class MasheryAPIClient extends Controller
{
    private $client = null;
    public $API_URL = 'https://api.mashery.com/v3/';
    private $auth_key;
    private $auth_secret;
    public $accessToken;

    public function __construct($key,$secret)
    {
        $this->auth_key = $key;
        $this->auth_secret = $secret;
        
       
        $this->client = new Client([
            'base_uri' => $this->API_URL,
            'headers' => [
                'Content-Type' => 'application/x-www-form-urlencoded'
            ],
            'auth' => [$this->auth_key, $this->auth_secret],
        ]);
    }

    public function prepareAccessToken()
    {
        $url = 'token';
        
        $body = [
            'grant_type' => 'password',
            'username' => 'marketplace.dev',
            'password' => 'Marketplace123',
            'scope' => '71338066-f062-4feb-84b7-6547f0dc4e82'
        ];

        $response = $this->client->request('POST', $url, [
            'body' => json_encode($body)
        ]);
        
        $result = json_decode($response->getBody()->getContents());

        $this->accessToken = $result->access_token;

        return $this->accessToken;
    }
}